!***********************************************************************
!*   
!*   Licensed Materials - Property of IBM.
!*   IBM XL Fortran Advanced Edition V10.1 for Linux (5724-M17)
!*   (C) Copyright IBM Corp. 2003, 2006.
!*   All Rights Reserved.
!*   US Government Users Restricted Rights - 
!*   Use, duplication or disclosure restricted by 
!*   GSA ADP Schedule Contract with IBM Corp.
!*
!***********************************************************************

      logical*4 fpstat(32)
      common /fpcomm/ fpstat 
!ibmt threadlocal /fpcomm/

!
! The following declarations are new to AIX XL Fortran Compiler.
! They define integers which are offsets into the array fpstat.
!
! Note: The naming convention for these integers is a prefix (fp for
!       Floating-Point) followed by the corresponding bit name in the
!       FPSCR (floating-point status and control register).  For more
!       information, consult the documentation on the FPGETS and FPSETS
!       Service and Utility Procedures in the XL Fortran User's Guide.
!
      !   fpfx     - Floating-point exception summary
      !   fpfex    - Floating-point enabled exception summary
      !   fpvx     - Floating-point invalid operation exception summary
      !   fpox     - Floating-point overflow exception
      !   fpux     - Floating-point underflow exception
      !   fpzx     - Floating-point zero divide exception
      !   fpxx     - Floating-point inexact exception
      !   fpvxsnan - Floating-point invalid operation exception (SNaN)
      !   fpvxisi  - Floating-point invalid operation exception (INF-INF)
      !   fpvxidi  - Floating-point invalid operation exception (INF/INF)
      !   fpvxzdz  - Floating-point invalid operation exception (0/0)
      !   fpvximz  - Floating-point invalid operation exception (INF*0)
      !   fpvxvc   - Floating-point invalid operation exception (invalid
      !              compare)
      !   fpfr     - Floating-point fraction rounded
      !   fpfi     - Floating-point fraction inexact
      !   fpc      - Floating-point result class descriptor
      !   fpfl     - Floating-point less than or negative
      !   fpfg     - Floating-point greater than or positive
      !   fpfe     - Floating-point equal or zero
      !   fpfu     - Floating-point unordered or NaN
      !   fpvxsoft - Floating-point invalid operation exception (software
      !              request)
      !   fpvxsqrt - Floating-point invalid operation exception (invalid
      !              square root)
      !   fpvxcvi  - Floating-point invalid operation exception (invalid
      !              integer convert)
      !   fpve     - Floating-point invalid operation exception enable
      !   fpoe     - Floating-point overflow exception enable
      !   fpue     - Floating-point underflow exception enable
      !   fpze     - Floating-point zero divide exception enable
      !   fpxe     - Floating-point inexact exception enable
      !   fprn1    - Floating-point rounding control
      !   fprn2    - Floating-point rounding control
      !   fpvxnans - Floating-point invalid operation exception (SNaN)
      !              (a synonym for fpvxsnan)

      integer*4 fpfx, fpfex, fpvx, fpox, fpux, fpzx, fpxx
      integer*4 fpvxsnan, fpvxisi, fpvxidi, fpvxzdz, fpvximz
      integer*4 fpvxvc, fpfr, fpfi, fpc, fpfl, fpfg, fpfe, fpfu
      integer*4 fpvxsoft, fpvxsqrt, fpvxcvi, fpve, fpoe, fpue, fpze
      integer*4 fpxe, fprn1, fprn2, fpvxnans
      parameter (fpfx = 1, fpfex = 2, fpvx = 3, fpox = 4, fpux = 5)
      parameter (fpzx = 6, fpxx = 7, fpvxsnan = 8, fpvxisi = 9)
      parameter (fpvxidi = 10, fpvxzdz = 11, fpvximz = 12)
      parameter (fpvxvc = 13, fpfr = 14, fpfi = 15, fpc = 16)
      parameter (fpfl = 17, fpfg = 18, fpfe = 19, fpfu = 20)
      parameter (fpvxsoft = 22, fpvxsqrt = 23, fpvxcvi = 24)
      parameter (fpve = 25, fpoe = 26, fpue = 27, fpze = 28)
      parameter (fpxe = 29, fprn1 = 31, fprn2 = 32, fpvxnans = 8)

! The following declarations allow compatibility
! with IBM AIX/RT XL FORTRAN and IBM RT PC FORTRAN 77
!
      !   fpeall   - Floating-point error interrupts
      !   fpeyes   - Floating-point error detected
      !   fpinva   - Invalid floating-point number detected
      !   fpainv   - Invalid number error interrupt
      !   fpdivz   - Divide-by-zero detected
      !   fpadiv   - Divide-by-zero error interrupt
      !   fpover   - Overflow detected
      !   fpaove   - Overflow error interrupt
      !   fpundr   - Underflow detected
      !   fpaund   - Underflow error interrupt
      !   fpinex   - Inexact result detected
      !   fpaine   - Inexact result error interrupt

      integer*4 fpeall, fpeyes, fpinva, fpainv, fpdivz, fpadiv
      integer*4 fpover, fpaove, fpundr, fpaund, fpinex, fpaine
      parameter (fpeall = 1, fpeyes = 2, fpinva = 3, fpainv = 25)
      parameter (fpdivz = 6, fpadiv = 28, fpover = 4, fpaove = 26)
      parameter (fpundr = 5, fpaund = 27, fpinex = 7, fpaine = 29)
