!***********************************************************************
!*   
!*   Licensed Materials - Property of IBM.
!*   IBM XL Fortran Advanced Edition V10.1 for Linux (5724-M17)
!*   (C) Copyright IBM Corp. 2003, 2006.
!*   All Rights Reserved.
!*   US Government Users Restricted Rights - 
!*   Use, duplication or disclosure restricted by 
!*   GSA ADP Schedule Contract with IBM Corp.
!*
!***********************************************************************
!
!            NOTICE TO USERS OF THE SOURCE CODE EXAMPLES
!
! THE SOURCE CODE EXAMPLES PROVIDED BY IBM ARE ONLY INTENDED TO ASSIST IN THE
! DEVELOPMENT OF A WORKING SOFTWARE PROGRAM.  THE SOURCE CODE EXAMPLES DO NOT
! FUNCTION AS WRITTEN:  ADDITIONAL CODE IS REQUIRED.  IN ADDITION, THE SOURCE
! CODE EXAMPLES MAY NOT COMPILE AND/OR BIND SUCCESSFULLY AS WRITTEN.
!
! INTERNATIONAL BUSINESS MACHINES CORPORATION PROVIDES THE SOURCE CODE
! EXAMPLES, BOTH INDIVIDUALLY AND AS ONE OR MORE GROUPS, "AS IS" WITHOUT
! WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT
! LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
! PARTICULAR PURPOSE.  THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE
! OF THE SOURCE CODE EXAMPLES, BOTH INDIVIDUALLY AND AS ONE OR MORE GROUPS,
! IS WITH YOU.  SHOULD ANY PART OF THE SOURCE CODE EXAMPLES PROVE
! DEFECTIVE, YOU (AND NOT IBM OR AN AUTHORIZED RISC System/6000* WORKSTATION
! DEALER) ASSUME THE ENTIRE COST OF ALL NECESSARY SERVICING, REPAIR OR
! CORRECTION.
!
! IBM does not warrant that the contents of the source code examples, whether
! individually or as one or more groups, will meet your requirements or that
! the source code examples are error-free.
!
! IBM may make improvements and/or changes in the source code examples at
! any time.
!
! Changes may be made periodically to the information in the source code
! examples; these changes may be reported in new editions of the examples.
!
! References in the source code examples to IBM products, programs, or
! services do not imply that IBM intends to make these available in all
! countries in which IBM operates.  Any reference to an IBM licensed
! program in the source code examples is not intended to state or imply
! that only IBM's licensed program may be used.  Any functionally equivalent
! program may be used.
!
! * RISC System/6000 is a trademark of International Business Machines
!   Corporation.


!-----------------------------------------------------------------------
! The sample routine fhandler is a SIGTRAP / SIGFPE signal handler that
! prints information about any signal generated and a stack traceback
! starting from the point where the trap occurred.  Program execution
! is terminated when a SIGTRAP / SIGFPE signal is received.
!-----------------------------------------------------------------------
@PROCESS XFLAG(CALLBY)

#ifdef LINUX_PPC
#ifndef __linux__
#define __linux__
#endif
#endif

#ifdef MACOS_PPC
#ifndef __APPLE__
#define __APPLE__
#endif
#endif

#if !defined(__linux__) && !defined(__APPLE__)
      ! Signal handler for AIX
      subroutine fhandler (%val(signal), %val(code), sigcontextdata)
#include <fsignal.h>

        __INT32 signal
        __INT32 code
        type(sigcontext) :: sigcontextdata

        include 'fexcp.h'

        ! The routine xl__sigdump, from libxlf90.a, prints
        ! information about the signal that was received and
        ! a traceback starting from the point where the signal
        ! was generated
        call xl__sigdump (%val(signal), %val(code), sigcontextdata)

        stop
      end

#else
      ! Signal handler for Linux or MacOS X
      subroutine fhandler (%val(signal), info, context)
#include "fsignal.h"

        __INT32 signal
        type(siginfo_t)  :: info
#if defined(__APPLE__) && defined(__64BIT__)
        type(ucontext64_t) :: context
#else
        type(ucontext_t) :: context
#endif

        include 'fexcp.h'

        ! The routine xl__sigdump, from libxlf90.(so or dylib) / libxlf90.a,
        ! prints information about the signal that was received and
        ! a traceback starting from the point where the signal
        ! was generated
        call xl__sigdump (%val(signal), info, context)

        stop
      end

#endif
