!***********************************************************************
!*   
!*   Licensed Materials - Property of IBM.
!*   IBM XL Fortran Advanced Edition V10.1 for Linux (5724-M17)
!*   (C) Copyright IBM Corp. 2003, 2006.
!*   All Rights Reserved.
!*   US Government Users Restricted Rights - 
!*   Use, duplication or disclosure restricted by 
!*   GSA ADP Schedule Contract with IBM Corp.
!*
!***********************************************************************
!
!            NOTICE TO USERS OF THE SOURCE CODE EXAMPLES
!
! THE SOURCE CODE EXAMPLES PROVIDED BY IBM ARE ONLY INTENDED TO ASSIST IN THE
! DEVELOPMENT OF A WORKING SOFTWARE PROGRAM.  THE SOURCE CODE EXAMPLES DO NOT
! FUNCTION AS WRITTEN:  ADDITIONAL CODE IS REQUIRED.  IN ADDITION, THE SOURCE
! CODE EXAMPLES MAY NOT COMPILE AND/OR BIND SUCCESSFULLY AS WRITTEN.
!
! INTERNATIONAL BUSINESS MACHINES CORPORATION PROVIDES THE SOURCE CODE
! EXAMPLES, BOTH INDIVIDUALLY AND AS ONE OR MORE GROUPS, "AS IS" WITHOUT
! WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT
! LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
! PARTICULAR PURPOSE.  THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE
! OF THE SOURCE CODE EXAMPLES, BOTH INDIVIDUALLY AND AS ONE OR MORE GROUPS,
! IS WITH YOU.  SHOULD ANY PART OF THE SOURCE CODE EXAMPLES PROVE
! DEFECTIVE, YOU (AND NOT IBM OR AN AUTHORIZED RISC System/6000* WORKSTATION
! DEALER) ASSUME THE ENTIRE COST OF ALL NECESSARY SERVICING, REPAIR OR
! CORRECTION.
!
! IBM does not warrant that the contents of the source code examples, whether
! individually or as one or more groups, will meet your requirements or that
! the source code examples are error-free.
!
! IBM may make improvements and/or changes in the source code examples at
! any time.
!
! Changes may be made periodically to the information in the source code
! examples; these changes may be reported in new editions of the examples.
!
! References in the source code examples to IBM products, programs, or
! services do not imply that IBM intends to make these available in all
! countries in which IBM operates.  Any reference to an IBM licensed
! program in the source code examples is not intended to state or imply
! that only IBM's licensed program may be used.  Any functionally equivalent
! program may be used.
!
! * RISC System/6000 is a trademark of International Business Machines
!   Corporation.

        program postmortem

!  A sample program to illustrate the use of the routines in check_fpsrc.f.
!  In this case, those routines are used to generate a postmortem indicating
!  any exceptions that have occurred during the execution of a program.
!  Finer checking granularity is possible by adding more calls to
!  reset_exception_bits and query_exception_bits.

!  Compile this test with 'xlf postmortem.f check_fpscr.f'.

!  prevent compile time arithmetic
        real*8 zero /0.0d0/

!  ensure all exception bits are clear
        call reset_exception_bits

!  generate a divide by zero exception
        print *, 1.0d0 / zero

!  print a summary of all floating point exceptions that have
!  occurred up to this point
        call query_exception_bits

        end
