!***********************************************************************
!*   
!*   Licensed Materials - Property of IBM.
!*   IBM XL Fortran Advanced Edition V10.1 for Linux (5724-M17)
!*   (C) Copyright IBM Corp. 2003, 2006.
!*   All Rights Reserved.
!*   US Government Users Restricted Rights - 
!*   Use, duplication or disclosure restricted by 
!*   GSA ADP Schedule Contract with IBM Corp.
!*
!***********************************************************************

!IBM* SOURCEFORM(free(f90))
 program sample
   interface
     subroutine cfunc1 (i4, %val(i2), %ref(i1), %val(i))
       integer(4) :: i4
       integer(2) :: i2
       integer(1) :: i1
       integer    :: i
     end subroutine

     subroutine cfunc2 (r1, %val(r2), %ref(r3), %val(r4))
       double precision :: r1, r2, r3, r4
     end subroutine

     subroutine cfunc3 (%val(x1), %val(x2))
       double complex :: x1, x2
     end subroutine

     subroutine cfunc4 (l1, %val(l2), %ref(l3), %val(l4))
       logical(4) :: l1, l2, l3, l4
     end subroutine

     subroutine cfunc5 (%val(c1), %ref(c2), %val(c3))
       character :: c1, c2, c3
     end subroutine
   end interface

   integer(4) :: i_arg1 = 1
   integer(2) :: i_arg2 = 2
   integer(1) :: i_arg3 = 3

   logical(4) :: l_arg1 = .TRUE.
   logical(4) :: l_arg2 = .FALSE.
   logical(4) :: l_arg3 = .FALSE.

   double precision :: r_arg1 = 1.0D0
   double precision :: r_arg2 = 2.0D0
   double precision :: r_arg3 = 3.0D0
   double complex   :: x_arg1 = (1.0D0, 2.0D0)

   character :: c_arg1 = 'a'
   character :: c_arg2 = 'b'


   ! Call "C" function using INTEGER arguments
   !   - Note that "i_arg1" and "i_arg3" are passed by reference
   !   - Note that "i_arg2" and x"0004" are passed by value
   call cfunc1 (i_arg1, i_arg2, i_arg3, x"0004")

   ! Call "C" function using REAL arguments
   !   - Note that "r_arg1" and "r_arg3" are passed by reference
   !   - Note that "r_arg2" and "4.0D0" are passed by value
   call cfunc2 (r_arg1, r_arg2, r_arg3, 4.0D0)

   ! Call "C" function using COMPLEX arguments
   !   - Note that "x_arg1" and "(5.0D0,6.0D0)" are passed by value
   call cfunc3 (x_arg1, (5.0D0, 6.0D0))

   ! Call "C" function using LOGICAL arguments
   !   - Note that "l_arg1" and "l_arg3" are passed by reference
   !   - Note that "l_arg2" and ".TRUE." are passed by value
   call cfunc4 (l_arg1, l_arg2, l_arg3, .TRUE.)

   ! Call "C" function using CHARACTER arguments
   !   - Note that "c_arg2" is passed by reference (with no length)
   !   - Note that "c_arg1" and "c" are passed by value
   call cfunc5 (c_arg1, c_arg2, 'c')
 end program
