!***********************************************************************
!*   
!*   Licensed Materials - Property of IBM.
!*   IBM XL Fortran Advanced Edition V10.1 for Linux (5724-M17)
!*   (C) Copyright IBM Corp. 2003, 2006.
!*   All Rights Reserved.
!*   US Government Users Restricted Rights - 
!*   Use, duplication or disclosure restricted by 
!*   GSA ADP Schedule Contract with IBM Corp.
!*
!***********************************************************************

      Module xlfutility
!
!
! Note: If this file is to be used for the 64-bit mode, the definition of
! TIME_SIZE should be changed to:
!
!       integer(4), parameter :: TIME_SIZE = 8
!
        integer(4), parameter :: TIME_SIZE = 4
        type iar
          sequence
          integer(4) ihr
          integer(4) imin
          integer(4) isec
        end type

        type idate_type
          sequence
          integer(4) iday
          integer(4) imonth
          integer(4) iyear
        end type

        type tb_type
          sequence
          real(4) usrtime
          real(4) systime
        end type

        interface
          integer(4) function alarm_(time, func)
            integer(4), intent(in) ::  time
            integer(4) func
          end function alarm_

          subroutine bic_(x1,x2)
           integer(4), intent(in) :: x1
            integer(4), intent(inout) :: x2
          end subroutine bic_

          subroutine bis_(x1,x2)
            integer(4), intent(in) :: x1
            integer(4), intent(inout) :: x2
          end subroutine bis_

          logical(4) function bit_(x1,x2)
            integer(4), intent(in) :: x1
            integer(4), intent(in) :: x2
          end function bit_

          character(8) function clock_()
          end function clock_

          subroutine ctime_(str, time)
            import TIME_SIZE
            character(*), intent(out) :: str
            integer(kind=TIME_SIZE), intent(in) :: time
          end subroutine ctime_

          character(8) function date()
          end function date

          real(4) function dtime_(dtime_struct)
            import tb_type
            type(tb_type), intent(out) :: dtime_struct
          end function dtime_

          real(4) function etime_(etime_struct)
            import tb_type
            type(tb_type), intent(out) :: etime_struct
          end function etime_

          subroutine exit_(exit_status)
            integer(4), intent(in) :: exit_status
          end subroutine exit_

          subroutine fdate_(str)
            character(*), intent(out) :: str
          end subroutine fdate_

          subroutine flush_(lunit)
            integer(4), intent(in) :: lunit
          end subroutine flush_

          subroutine fpgets(fpstat)
            logical(4), intent(out) :: fpstat(32)
          end subroutine fpgets

          subroutine fpsets(fpstat)
            logical(4), intent(in) :: fpstat(32)
          end subroutine fpsets

          subroutine getarg(i1,c1)
            integer(4), intent(in) :: i1
            character(*), intent(out) :: c1
          end subroutine getarg

          integer(4) function getcwd_(name)
            character(*), intent(out) :: name
          end function getcwd_

          integer(4) function getfd(lunit)
            integer(4), intent(in) :: lunit
          end function getfd

          integer(4) function getgid_()
          end function getgid_

          subroutine getlog_(name)
            character(*), intent(out) :: name
          end subroutine getlog_

          integer(4) function getpid_()
          end function getpid_

          integer(4) function getuid_()
          end function getuid_

          subroutine gmtime_(stime, tarray)
            import TIME_SIZE
            integer(kind=TIME_SIZE), intent(in) :: stime
            integer(4), intent(out) :: tarray(9)
          end subroutine gmtime_

          integer(4) function hostnm_(name)
           character(*), intent(out) :: name
          end function hostnm_

          integer(4) function iargc()
          end function iargc

          subroutine idate_(idate_struct)
            import idate_type
            type(idate_type), intent(out) :: idate_struct
          end subroutine idate_

          integer(4) function ierrno_()
          end function ierrno_

          integer(4) function irand()
          end function irand

          integer(8) function irtc()
          end function irtc

          subroutine itime_(itime_struct)
            import iar
            type(iar), intent(out) :: itime_struct
          end subroutine itime_

          character(8) function jdate()
          end function jdate

          integer(4) function lenchr_(str)
            character(*), intent(in) :: str
          end function lenchr_

          integer(4) function lnblnk_(str)
            character(*), intent(in) :: str
          end function lnblnk_

          subroutine ltime_(stime, tarray)
            import TIME_SIZE
            integer(kind=TIME_SIZE), intent(in) :: stime
            integer(4), intent(out) :: tarray(9)
          end subroutine ltime_

          integer(4) function mclock()
          end function mclock

          real(8) function rtc()
          end function rtc

          subroutine setrteopts(c1)
            character(*), intent(in) :: c1
          end subroutine setrteopts

          subroutine sleep_(sec)
            integer(4), intent(in) :: sec
          end subroutine sleep_

          real(8) function timef()
          end function timef

          function time_()
            import TIME_SIZE
            integer(kind=TIME_SIZE) time_
          end function time_

          integer(4) function umask_(cmask)
            integer(4), intent(in) :: cmask
          end function umask_

          integer(4) function usleep_(msec)
            integer(4), intent(in) :: msec
          end function usleep_
     
          integer(4) function ftell_(lunit)
            integer(4), intent(in) :: lunit
          end function ftell_

          integer(8) function ftell64_(lunit)
            integer(4), intent(in) :: lunit
          end function ftell64_

        end interface

      end module
